package com.hncy.sjdz.constant;

/**
 * @author zhaoting
 * @date 2019-04-28
 * <p>
 * 缓存的key 常量
 */
public interface CacheConstants {

    /**
     * 全局缓存，在缓存名称上加上该前缀表示该缓存不区分租户，比如:
     * <p/>
     * {@code @Cacheable(value = CacheConstants.GLOBALLY+CacheConstants.MENU_DETAILS, key = "#roleId  + '_menu'", unless = "#result == null")}
     */
    String GLOBALLY = "gl:";

    /**
     * 用户缓存信息
     */
    String USER_DETAILS = "user_details_hnsoftware";

    /**
     * oauth 客户端信息
     */
    String CLIENT_DETAILS_KEY = "hnsoftware_oauth:client:details";

    /**
     * 验证码前缀
     */
    String DEFAULT_CODE_KEY = "DEFAULT_CODE_KEY";

    /**
     * 忘记密码
     */
    String FORGET_CODE_KEY = "forget_code_key";

    String GRANT_CODE_KEY = "grant_code_key";

    /**
     * Rsa加密
     */
    String RSA_KEY = "RSA_KEY:";

    /**
     * 字典信息缓存
     */
    String DICT_DETAILS = "dict_details_hnsoftware";

    /* license */
    String AUTH_FILE_KEY = "license:cncloudAuthKey";

    String PARAMS_DETAILS = "params_details_hnsoftware";

    String EMPLOY_DETAILS = "employ_details";

    String COUNSELOR_MINI_USER_DETAILS = GLOBALLY + "counselor_mini_user_details";

}
