package com.hncy.sjdz.constant.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/**
 * @author tyangzhou 事件操作
 */

@Getter
@RequiredArgsConstructor
public enum FileTypeEnum {

    PICTURE_JPEG(".jpeg", "图片"), PICTURE_JPG(".jpg", "图片"), PICTURE_PNG(".png", "图片"), PICTURE_GIF(".gif", "图片"),
    PICTURE_BMP(".bmp", "图片"), PICTURE_MP4(".mp4", "视频"), VIDEO_AVI(".avi", "视频"), VIDEO_MKV(".mkv", "视频"),
    VIDEO_MOV(".mov", "视频"), DOC_PDF(".pdf", "文档"), DOC_DOCX(".docx", "文档"), DOC_XLSX(".xlsx", "文档"),
    DOC_PPTX(".pptx", "文档"), AUDIO_MP3(".mp3", "音频"), AUDIO_WAV(".wav", "音频"), AUDIO_AAC(".aac", "音频"),
    ZIP_ZIP(".zip", "压缩文件"), ZIP_RAR(".rar", "压缩文件");

    private final String name;

    @EnumValue
    @JsonValue
    private final String value;

    public static FileTypeEnum getByName(String name) {
        FileTypeEnum[] enums = FileTypeEnum.values();
        for (FileTypeEnum nowEnum : enums) {
            if (name.toLowerCase().endsWith(nowEnum.getName())) {
                return nowEnum;
            }
        }
        return null;
    }

}
