package com.hncy.sjdz.util;

import cn.hutool.core.bean.BeanUtil;

import java.util.Collection;
import java.util.Map;

/**
 * @author zhaoting
 * @date 2022/5/27 9:50
 */
public class BeanUtils extends BeanUtil {

    /**
     * 可以用于判断 Map,Collection,String,Array,Long,Short等是否为空
     * @param o java.lang.Object.
     * @return boolean.
     */
    public static boolean isEmpty(Object o) {
        if (o == null) {
            return true;
        }
        if (o instanceof String) {
            return ((String) o).trim().length() == 0;
        }
        if (o instanceof Collection) {
            return ((Collection) o).isEmpty();
        }
        if (o.getClass().isArray()) {
            return ((Object[]) o).length == 0;
        }
        if (o instanceof Map) {
            return ((Map) o).isEmpty();
        }
        return false;

    }

    /**
     * 判断是否为数字
     * @param o
     * @return
     */
    public static boolean isNumber(Object o) {
        if (o == null) {
            return false;
        }
        if (o instanceof Number) {
            return true;
        }
        if (o instanceof String) {
            try {
                Double.parseDouble((String) o);
                return true;
            }
            catch (NumberFormatException e) {
                return false;
            }
        }
        return false;
    }

}
