package com.hncy.sjdz.base.controller;


import com.hncy.sjdz.base.models.entity.Component;
import com.hncy.sjdz.base.service.ComponentService;
import com.hncy4cloud.hncy.common.core.util.R;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Tag(name = "gridResources", description = "网格资源")
@Slf4j
@RestController
@RequestMapping("/gridResources")
public class GridResourcesController {

	@Resource
	private ComponentService componentService;

	@Operation(summary = "网格资源")
	@PostMapping("/getGridResources")
	public R getGridResources() {
		return componentService.getGridResources();
	}

	@Operation(summary = "网格内-部件类型统计")
	@PostMapping("/getComponentTypeStatistics")
	public R getComponentTypeStatistics() {
		return R.ok(componentService.getComponentTypeStatistics());
	}

	@Operation(summary = "网格内-部件大小类别统计")
	@PostMapping("/getComponentClassStatistics")
	public R getComponentClassStatistics() {
		return R.ok(componentService.getComponentClassStatistics());
	}

	@Operation(summary = "网格内-处置资源数量统计")
	@PostMapping("/getResourcesCount")
	public R getResourcesCount() {
		return R.ok(componentService.getResourcesCount());
	}


}
