package com.hncy.sjdz.base.controller;


import com.hncy.sjdz.base.service.SafetyMonitoringObjectInfoService;
import com.hncy4cloud.hncy.common.core.util.R;
import io.swagger.v3.oas.annotations.Parameter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.bind.annotation.GetMapping;


/**
 * 监测对象表
 *
 * @author cp
 * @since 2024-11-07 15:23:28
 */
@RestController
@RequestMapping("/safetyMonitoringObjectInfo")
public class SafetyMonitoringObjectInfoController {

	@Autowired
	private SafetyMonitoringObjectInfoService safetyMonitoringObjectInfoService;

	/**
	 * 统计各风险等级设施数
	 *
	 * @return
	 */
	@GetMapping("/statisticalRiskLevel")
	public R statisticalRiskLevel(@Parameter(name = "parentTypeCode", description = "监测对象类别父级code", required = false)
								  @RequestParam(name = "parentTypeCode", required = false) String parentTypeCode) {

		return safetyMonitoringObjectInfoService.statisticalRiskLevel(parentTypeCode);
	}

	/**
	 * 统计当前风险预警设施类型
	 *
	 * @return
	 */
	@GetMapping("/statisticalType")
	public R statisticalType() {

		return safetyMonitoringObjectInfoService.statisticalType();
	}

	/**
	 * 风险源点位
	 *
	 * @return
	 */
	@GetMapping("/findListForMap")
	public R findListForMap(@Parameter(name = "parentTypeCode", description = "监测对象类别父级code", required = false)
							@RequestParam(name = "parentTypeCode", required = false) String parentTypeCode,
							@Parameter(name = "monitoringObjectTypeCodeList", description = "监测对象类別编码集合", required = false)
							@RequestParam(name = "monitoringObjectTypeCodeList", required = false) String monitoringObjectTypeCodeList,
							@Parameter(name = "lat", description = "纬度", required = true)
							@RequestParam(name = "lat", required = true) String lat,
							@Parameter(name = "lon", description = "经度", required = true)
							@RequestParam(name = "lon", required = true) String lon,
							@Parameter(name = "distance", description = "距离", required = true)
							@RequestParam(name = "distance", required = true) String distance,
							@Parameter(name = "page", description = "页码", required = true, example = "1") @RequestParam(name = "page", defaultValue = "1") int page,
							@Parameter(name = "count", description = "每页条数", required = true, example = "10") @RequestParam(name = "count", defaultValue = "10") int count
							) {

		return safetyMonitoringObjectInfoService.findListForMap(parentTypeCode, monitoringObjectTypeCodeList,lat,lon,distance);
	}


	/**
	 * 设施详情
	 *
	 * @return
	 */
	@GetMapping("/getInfo")
	public R getInfo(@Parameter(name = "id", description = "设施id", required = false)
					 @RequestParam(name = "id", required = false) String id) {

		return safetyMonitoringObjectInfoService.getInfo(id);
	}


}