package com.hncy.sjdz.base.controller;


import com.hncy.sjdz.base.service.SafetyRiskEventInfoService;
import com.hncy4cloud.hncy.common.core.util.R;
import io.swagger.v3.oas.annotations.Parameter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.bind.annotation.GetMapping;


/**
 * 风险事件表
 *
 * @author cp
 * @since 2024-11-07 15:33:16
 */
@RestController
@RequestMapping("/safetyRiskEventInfo")
public class SafetyRiskEventInfoController {

	@Autowired
	private SafetyRiskEventInfoService safetyRiskEventInfoService;


	/**
	 * 统计今日预警，受理代办，处置回复数量
	 *
	 * @return
	 */
	@GetMapping("/statisticalEvent")
	public R statisticalEvent(@Parameter(name = "parentTypeCode", description = "监测对象类别父级code", required = false)
								  @RequestParam(name = "parentTypeCode", required = false) String parentTypeCode) {
		return safetyRiskEventInfoService.statisticalEvent(parentTypeCode);
	}


	/**
	 * 事件分页列表
	 *
	 * @return
	 */
	@GetMapping("/eventPage")
	public R eventPage(@Parameter(name = "page", description = "页码", required = true, example = "1")
					   @RequestParam(name = "page", defaultValue = "1") int page,
					   @Parameter(name = "count", description = "每页条数", required = true, example = "10")
					   @RequestParam(name = "count", defaultValue = "10") int count, @Parameter(name = "parentTypeCode", description = "监测对象类别父级code", required = false)
					   @RequestParam(name = "parentTypeCode", required = false) String parentTypeCode,
					   @Parameter(name = "riskLevelCode", description = "风险等级", required = false)
					   @RequestParam(name = "riskLevelCode", required = false) String riskLevelCode,
					   @Parameter(name = "disposalStatus", description = "处置状态", required = false)
					   @RequestParam(name = "disposalStatus", required = false) String disposalStatus,
					   @Parameter(name = "source", description = "来源方式", required = false)
					   @RequestParam(name = "source", required = false) String source) {
		return safetyRiskEventInfoService.eventPage(parentTypeCode, riskLevelCode, disposalStatus, source);
	}


	/**
	 * 事件详情
	 *
	 * @return
	 */
	@GetMapping("/getInfo")
	public R getInfo(@Parameter(name = "riskId", description = "事件id", required = false)
					 @RequestParam(name = "riskId", required = false) String riskId) {
		return safetyRiskEventInfoService.getInfo(riskId);
	}
}