package com.hncy.sjdz.base.models.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 数据底座-重大项目信息
 * @TableName sjdz_major_project
 */
@Data
public class SjdzMajorProjectVO implements Serializable {
    /**
     * id
     */
    @TableId
    private String id;

    /**
     * 项目名
     */
    private String projectName;

    /**
     * 单位名
     */
    private String unitName;

    /**
     * 预算金额 万元
     */
    private String budgetAmount;

    /**
     * 计划开工启动时间
     */
	@JsonFormat(pattern = "yyyy年MM月dd日")
    private LocalDate startDate;

    /**
     * 计划竣工启动时间
     */
	@JsonFormat(pattern = "yyyy年MM月dd日")
    private LocalDate endDate;

    /**
     * 项目内容
     */
    private String projectContent;

	/**
	 * 第一季度实施计划
	 */
	private String phasePlanOne;

	/**
	 * 第二季度实施计划
	 */
	private String phasePlanTwo;

	/**
	 * 第三季度实施计划
	 */
	private String phasePlanThird;

	/**
	 * 第四季度实施计划
	 */
	private String phasePlanFour;

    /**
     * 责任人姓名
     */
    private String projectLeader;

    /**
     * 责任人电话
     */
    private String leaderContact;

    /**
     * 联络人姓名
     */
    private String liaisonName;

    /**
     * 联络人电话
     */
    private String liaisonContact;

    /**
     * 项目状态 1未启动 2进行中 3已完成
     */
    private String projectStatus;


    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}