package com.hncy.sjdz.base.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.csp.sentinel.util.StringUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hncy.sjdz.base.mapper.CallInformationMapper;
import com.hncy.sjdz.base.models.entity.CallInformation;
import com.hncy.sjdz.base.models.entity.EventAttachmentInfo;
import com.hncy.sjdz.base.models.entity.SjdzQzTj;
import com.hncy.sjdz.base.models.vo.EventInformationVO;
import com.hncy.sjdz.base.service.CallInformationService;
import com.hncy4cloud.hncy.common.core.util.R;
import com.hncy4cloud.hncy.common.core.util.RedisUtils;
import com.hncy4cloud.hncy.common.mybatis.custom.CustomPage;
import com.hncy4cloud.hncy.common.mybatis.custom.HncyPageHelper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * 网络理政来电信息-基本信息
 *
 * @author zhaoting
 * @date 2024-11-12 12:18:51
 */
@Service
public class CallInformationServiceImpl extends ServiceImpl<CallInformationMapper, CallInformation> implements CallInformationService {

	@Value(value = "${file.minio-prefix-url}")
	private String ossPrefix;
	@Override
	public R<CustomPage<EventInformationVO>> getEventInfoPage(Integer page, Integer count, String area, String keyWord) {
		if(StringUtil.isNotEmpty(area) ){
			if(area.contains("成都") ){
				area=null;
			}
		}
		LocalDate currentDate = LocalDate.now();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
		String time = currentDate.format(formatter);

		CustomPage<EventInformationVO>  eventInformationVOCustomPage =(CustomPage<EventInformationVO>)RedisUtils.get("callInformation:"+page+":"+count+":" + area);
		if(eventInformationVOCustomPage==null){
			String finalArea = area;
			  eventInformationVOCustomPage = HncyPageHelper.doSelectPage(() -> baseMapper.getEventInfoPage(finalArea,keyWord,time));
			List<EventInformationVO> items = eventInformationVOCustomPage.getItems();
			for (EventInformationVO item : items) {
				String type = item.getType();
				if("2".equals(type)){
					List<EventAttachmentInfo> eventAttachmentInfos = baseMapper.listEventAttachmentInfo(item.getId());
					if(CollUtil.isNotEmpty(eventAttachmentInfos)){
						for(EventAttachmentInfo eventAttachmentInfo : eventAttachmentInfos){
							String path = eventAttachmentInfo.getPath();
							if(StringUtils.isNotEmpty(path)){
								if(!path.contains("http")) {
									eventAttachmentInfo.setPath(ossPrefix + "/" + path);
								}
							}
						}
						item.setEventAttachmentInfos(eventAttachmentInfos);
					}
				}
			}
			if(eventInformationVOCustomPage!=null){
				RedisUtils.set("callInformation:"+page+":"+count+":"  + area,eventInformationVOCustomPage,60*60*1);
			}
		}

		return R.ok(eventInformationVOCustomPage);
	}

	@Override
	public R getSjdzQzTjNewest(String area) {
		if(StringUtil.isNotEmpty(area) ){
			if(area.contains("成都") ){
				area=null;
			}
		}
		LocalDate currentDate = LocalDate.now();
		DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
		String time = currentDate.format(formatter);
		SjdzQzTj sjdzQzTj=baseMapper.getSjdzQzTjNewest(area,time);
		sjdzQzTj.setJzTime(LocalDateTime.now());
		return R.ok(sjdzQzTj);
	}
}