package com.hncy.sjdz.base.service.impl;


import com.baomidou.mybatisplus.core.toolkit.Wrappers;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hncy.sjdz.base.mapper.SafetyMonitoringObjectInfoMapper;
import com.hncy.sjdz.base.mapper.SafetyMonitoringRecordInfoMapper;
import com.hncy.sjdz.base.models.entity.SafetyMonitoringObjectInfo;
import com.hncy.sjdz.base.models.entity.SafetyMonitoringRecordInfo;
import com.hncy.sjdz.base.service.SafetyMonitoringObjectInfoService;
import com.hncy4cloud.hncy.common.core.util.R;
import com.hncy4cloud.hncy.common.mybatis.custom.CustomPage;
import com.hncy4cloud.hncy.common.mybatis.custom.HncyPageHelper;
import io.swagger.v3.core.util.Json;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author cp
 * @since 2024-11-07 15:23:28
 */
@Service
@Slf4j
public class SafetyMonitoringObjectInfoServiceImpl extends ServiceImpl<SafetyMonitoringObjectInfoMapper, SafetyMonitoringObjectInfo> implements SafetyMonitoringObjectInfoService {

	@Autowired
	private SafetyMonitoringObjectInfoMapper safetyMonitoringObjectInfoMapper;
	@Autowired
	private SafetyMonitoringRecordInfoMapper safetyMonitoringRecordInfoMapper;

	@Override
	public R statisticalRiskLevel(String parentTypeCode) {
		return R.ok(safetyMonitoringObjectInfoMapper.statisticalRiskLevel(parentTypeCode));
	}


	@Override
	public R findListForMap(String parentTypeCode, String monitoringObjectTypeCodeList, String lat, String lon, String distance) {
		String[] split = null;
		if (monitoringObjectTypeCodeList != null && !monitoringObjectTypeCodeList.equals("")) {
			split = monitoringObjectTypeCodeList.split(",");
		}
		List<Map> listForMap = safetyMonitoringObjectInfoMapper.findListForMap(parentTypeCode, split, lat, lon, distance);
		CustomPage pageItem = HncyPageHelper.startManualPage(listForMap);
		return R.ok(pageItem);
	}


	@Override
	public R getInfo(String id) {
		Map map = safetyMonitoringObjectInfoMapper.getInfo(id);
		List<SafetyMonitoringRecordInfo> list = safetyMonitoringRecordInfoMapper.selectList(Wrappers.<SafetyMonitoringRecordInfo>lambdaQuery()
				.eq(SafetyMonitoringRecordInfo::getMonitoringObjectId, id)
				.groupBy(SafetyMonitoringRecordInfo::getMonitoringProject));
		List projectList = new ArrayList<>();
		for (SafetyMonitoringRecordInfo safetyMonitoringRecordInfo : list) {
			Map recordMap = new HashMap<>();
			List<Map> projectInfo = safetyMonitoringObjectInfoMapper.selectByMonitoringProject(id, safetyMonitoringRecordInfo.getMonitoringProject());
			for (Map projectInfoMap : projectInfo) {
				  projectInfoMap.get("monitoringValue");
			}
			recordMap.put("projectName", safetyMonitoringRecordInfo.getMonitoringProject());
			recordMap.put("reportObjectList", projectInfo);
			projectList.add(recordMap);
		}
		map.put("projectList", projectList);
		return R.ok(map);
	}


	@Override
	public R statisticalType() {
		return R.ok(safetyMonitoringObjectInfoMapper.statisticalType());
	}
}