package com.hncy.sjdz.base.service.impl;


import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.hncy.sjdz.base.mapper.SafetyEventDealingRecordMapper;
import com.hncy.sjdz.base.mapper.SafetyMonitoringRecordInfoMapper;
import com.hncy.sjdz.base.mapper.SafetyRiskEventInfoMapper;
import com.hncy.sjdz.base.models.entity.SafetyEventDealingRecord;
import com.hncy.sjdz.base.models.entity.SafetyMonitoringRecordInfo;
import com.hncy.sjdz.base.models.entity.SafetyRiskEventInfo;
import com.hncy.sjdz.base.service.SafetyRiskEventInfoService;
import com.hncy4cloud.hncy.common.core.util.R;
import com.hncy4cloud.hncy.common.mybatis.custom.CustomPage;
import com.hncy4cloud.hncy.common.mybatis.custom.HncyPageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author cp
 * @since 2024-11-07 15:33:16
 */
@Service
@Slf4j
public class SafetyRiskEventInfoServiceImpl extends ServiceImpl<SafetyRiskEventInfoMapper, SafetyRiskEventInfo> implements SafetyRiskEventInfoService {

	@Autowired
	private SafetyRiskEventInfoMapper safetyRiskEventInfoMapper;
	@Autowired
	private SafetyEventDealingRecordMapper safetyEventDealingRecordMapper;

	@Autowired
	private SafetyMonitoringRecordInfoMapper safetyMonitoringRecordInfoMapper;


	@Override
	public R statisticalEvent(String parentTypeCode) {
		return R.ok(safetyRiskEventInfoMapper.statisticalEvent(parentTypeCode));
	}


	@Override
	public R eventPage(String parentTypeCode, String riskLevelCode, String disposalStatus, String source) {
		List<Map> list = safetyRiskEventInfoMapper.eventPage(parentTypeCode, riskLevelCode, disposalStatus, source);
		CustomPage pageItem = HncyPageHelper.startManualPage(list);
		return R.ok(pageItem);
	}

	@Override
	public R getInfo(String riskId) {
		Map map = safetyRiskEventInfoMapper.getInfo(riskId);
		List<SafetyEventDealingRecord> safetyEventDealingRecords = safetyEventDealingRecordMapper.selectList(Wrappers.<SafetyEventDealingRecord>lambdaQuery()
				.eq(SafetyEventDealingRecord::getRiskEventId, riskId)
				.orderByAsc(SafetyEventDealingRecord::getDealingTime));
		map.put("recordList", safetyEventDealingRecords);
		SafetyMonitoringRecordInfo safetyMonitoringRecordInfo = safetyMonitoringRecordInfoMapper.selectMonitoringValueById(riskId);
		if(safetyMonitoringRecordInfo!=null){
			map.put("monitoringProject", safetyMonitoringRecordInfo.getMonitoringProject());
			map.put("monitoringValue", safetyMonitoringRecordInfo.getMonitoringValue());
			List<SafetyMonitoringRecordInfo> list = safetyMonitoringRecordInfoMapper.selectList(Wrappers.<SafetyMonitoringRecordInfo>lambdaQuery()
					.eq(SafetyMonitoringRecordInfo::getMonitoringObjectId, safetyMonitoringRecordInfo.getMonitoringObjectId())
					.eq(SafetyMonitoringRecordInfo::getMonitoringProject, safetyMonitoringRecordInfo.getMonitoringProject())
					.eq(SafetyMonitoringRecordInfo::getReportObject, safetyMonitoringRecordInfo.getReportObject())
					.orderByDesc(SafetyMonitoringRecordInfo::getReportTime));
			map.put("currentMonitoringValue", list.get(0).getMonitoringValue());
		}

		return R.ok(map);
	}
}